<?php namespace Hugh\Curl;


class CurlService {

    /**
     * @param $url string   The URL to which the request is to be sent
     * @return Builder
     */
    public function to($url)
    {
        $builder = new Builder();
        if (class_exists(\Hugh\MultiCurl\Builder::class)) {
            $tracer = debug_backtrace(DEBUG_BACKTRACE_PROVIDE_OBJECT, 2);
            $line = $tracer[1]['line'] - 1;
            $content = explode("\n", file_get_contents($tracer[1]['file']));
            $beforeCommand = substr($content[$line],0,strpos($content[$line], 'Curl::to'));
            $beforeContent = implode("\n", array_slice($content, 0, $line)) .
                "\n" . $beforeCommand;
            $beforeContent = substr($beforeContent,
                strrpos($beforeContent, ';') + 1, strrpos($beforeContent, '('));

            if (str_contains($beforeContent, 'MultiCurl')) {
                $builder->multiple();
            }
        }

        return $builder->to($url);
    }

}